com.smartgwt.client.widgets

## Class RichTextEditor

- java.lang.Object
- - com.google.gwt.user.client.ui.UIObject
  - - com.google.gwt.user.client.ui.Widget
    - - com.smartgwt.client.widgets.BaseWidget
      - - com.smartgwt.client.widgets.Canvas
        - - com.smartgwt.client.widgets.layout.Layout
          - - com.smartgwt.client.widgets.layout.VLayout
            - - com.smartgwt.client.widgets.RichTextEditor

- All Implemented Interfaces:
    com.google.gwt.event.logical.shared.HasAttachHandlers, com.google.gwt.event.shared.HasHandlers, com.google.gwt.user.client.EventListener, com.google.gwt.user.client.ui.HasVisibility, com.google.gwt.user.client.ui.IsWidget, LogicalStructure, HasClickHandlers, HasDoubleClickHandlers, HasDragMoveHandlers, HasDragRepositionMoveHandlers, HasDragRepositionStartHandlers, HasDragRepositionStopHandlers, HasDragResizeMoveHandlers, HasDragResizeStartHandlers, HasDragResizeStopHandlers, HasDragStartHandlers, HasDragStopHandlers, HasDropHandlers, HasDropMoveHandlers, HasDropOutHandlers, HasDropOverHandlers, HasFocusChangedHandlers, HasHoverHandlers, HasHoverHiddenHandlers, HasKeyDownHandlers, HasKeyPressHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseStillDownHandlers, HasMouseUpHandlers, HasMouseWheelHandlers, HasMovedHandlers, HasParentMovedHandlers, HasResizedHandlers, HasRightMouseDownHandlers, HasScrolledHandlers, HasShowContextMenuHandlers, HasVisibilityChangedHandlers, HasMembersChangedHandlers

      public class RichTextEditor
      extends VLayout

  RichTextEditing component. Provides a rich-text editing area along with UI for executing rich-text commands on selected content.

  The HTML generated from this component may vary by browser, and, as with any HTML value created on the client, we recommend values be sanitized on the server before storing and displaying to other users.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class com.google.gwt.user.client.ui.UIObject

      `com.google.gwt.user.client.ui.UIObject.DebugIdImpl, com.google.gwt.user.client.ui.UIObject.DebugIdImplEnabled`

  - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.widgets.BaseWidget

      `config, configOnly, factoryCreated, factoryProperties, id, nativeObject, scClassName`

    - ### Fields inherited from class com.google.gwt.user.client.ui.UIObject

      `DEBUG_ID_PREFIX`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `RichTextEditor()`
    `RichTextEditor(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, Canvas defaults)` Changes the defaults for Canvas AutoChildren named `autoChildName`.
    `static void` | `changeAutoChildDefaults(java.lang.String autoChildName, FormItem defaults)` Changes the defaults for FormItem AutoChildren named `autoChildName`.
    `protected com.google.gwt.core.client.JavaScriptObject` | `create()`
    `void` | `doWarn()` Display a warning if Rich Text Editing is not fully supported in this browser.
    `java.lang.String` | `getAlignCenterPrompt()` The prompt for the built-in `alignCenter` control.
    `java.lang.String` | `getAlignLeftPrompt()` The prompt for the built-in `alignLeft` control.
    `java.lang.String` | `getAlignRightPrompt()` The prompt for the built-in `alignRight` control.
    `java.lang.String` | `getBackgroundColorPrompt()` The prompt for the built-in `backgroundColor` control.
    `java.lang.String` | `getBoldSelectionPrompt()` The prompt for the built-in `boldSelection` control.
    `java.lang.String` | `getColorPrompt()` The prompt for the built-in `color` control.
    `java.lang.String` | `getCopySelectionPrompt()` The prompt for the built-in `copySelection` control.
    `java.lang.String` | `getCutSelectionPrompt()` The prompt for the built-in `cutSelection` control.
    `Canvas` | `getEditArea()` The edit canvas created automatically for this RichTextEditor.
    `java.lang.String` | `getEditAreaBackgroundColor()` Background color for the `edit canvas`.
    `java.util.Map<java.lang.String,java.lang.String>` | `getFontNames()` ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    `SelectItem` | `getFontSelectorItem()` The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font to apply to the current selection.
    `java.lang.String` | `getFontSelectorPrompt()` The prompt for the built-in `font selector`.
    `java.util.Map<java.lang.String,java.lang.String>` | `getFontSizes()` ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    `SelectItem` | `getFontSizeSelectorItem()` The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font-size to apply to the current selection.
    `java.lang.String` | `getFontSizeSelectorPrompt()` The prompt for the built-in `font-size selector`.
    `java.lang.String` | `getIndentPrompt()` The prompt for the built-in `indent` control.
    `java.lang.String` | `getItalicSelectionPrompt()` The prompt for the built-in `italicSelection` control.
    `java.lang.String` | `getJustifyPrompt()` The prompt for the built-in `justify` control.
    `java.lang.String` | `getLinkPrompt()` The prompt for the built-in `hyperlink` control.
    `java.lang.String` | `getLinkUrlTitle()` The prompt displayed when editing a hyperlink.
    `ListPropertiesDialog` | `getListPropertiesDialog()` Dialog shown when the `"listProperties" control` is pressed.
    `java.lang.String` | `getListPropertiesPrompt()` The prompt for the built-in `listProperties` control.
    `java.lang.String` | `getListPropertiesWarningText()` The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `getLogicalStructure()` Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `boolean` | `getMoveFocusOnTab()` If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    `static RichTextEditor` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `java.lang.String` | `getOrderedListPrompt()` The prompt for the built-in `orderedList` control.
    `java.lang.String` | `getOutdentPrompt()` The prompt for the built-in `outdent` control.
    `java.lang.String` | `getPasteSelectionPrompt()` The prompt for the built-in `pasteSelection` control.
    `java.lang.String` | `getStrikethroughSelectionPrompt()` The prompt for the built-in `strikethroughSelection` control.
    `Layout` | `getToolArea()` Layout used to contain all of the `toolbar` AutoChildren that contain the `controlGroups`.
    `Layout` | `getToolbar()` Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists.
    `java.lang.String` | `getToolbarBackgroundColor()` The background color for the toolbar.
    `java.lang.String` | `getUnderlineSelectionPrompt()` The prompt for the built-in `underlineSelection` control.
    `java.lang.String` | `getUnorderedListPrompt()` The prompt for the built-in `unorderedList` control.
    `java.lang.String` | `getValue()` Initial value for the edit area.
    `java.lang.Boolean` | `richEditorSupported()` Does this browser support the full RichTextEditor feature set.
    `void` | `setAlignCenterPrompt(java.lang.String alignCenterPrompt)` The prompt for the built-in `alignCenter` control.
    `void` | `setAlignLeftPrompt(java.lang.String alignLeftPrompt)` The prompt for the built-in `alignLeft` control.
    `void` | `setAlignRightPrompt(java.lang.String alignRightPrompt)` The prompt for the built-in `alignRight` control.
    `void` | `setBackgroundColorPrompt(java.lang.String backgroundColorPrompt)` The prompt for the built-in `backgroundColor` control.
    `void` | `setBoldSelectionPrompt(java.lang.String boldSelectionPrompt)` The prompt for the built-in `boldSelection` control.
    `void` | `setBulletControls(ControlName... bulletControls)` Default HTML list control group.
    `void` | `setBulletControls(java.lang.Object... bulletControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setBulletControls(com.smartgwt.client.types.ControlName...) setBulletControls(ControlName...
    `void` | `setColorControls(ControlName... colorControls)` Control group for modifying text color / background color.
    `void` | `setColorControls(java.lang.Object... colorControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setColorControls(com.smartgwt.client.types.ControlName...) setColorControls(ControlName...
    `void` | `setColorPrompt(java.lang.String colorPrompt)` The prompt for the built-in `color` control.
    `void` | `setControlGroups(java.lang.Object... controlGroups)` An array of control groups specifying which groups of controls should be included in the editor tool area.
    `void` | `setControlGroups(java.lang.String... controlGroups)` An array of control group names specifying which groups of controls should be included in the editor tool area.
    `void` | `setCopySelectionPrompt(java.lang.String copySelectionPrompt)` The prompt for the built-in `copySelection` control.
    `void` | `setCutSelectionPrompt(java.lang.String cutSelectionPrompt)` The prompt for the built-in `cutSelection` control.
    `static void` | `setDefaultProperties(RichTextEditor richTextEditorProperties)` Class level method to set the default properties of this class.
    `void` | `setEditAreaBackgroundColor(java.lang.String editAreaBackgroundColor)` Background color for the `edit canvas`.
    `void` | `setFontControls(ControlName... fontControls)` Default font control group.
    `void` | `setFontControls(java.lang.Object... fontControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setFontControls(com.smartgwt.client.types.ControlName...) setFontControls(ControlName...
    `void` | `setFontNames(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontNames)` ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
    `void` | `setFontSelectorPrompt(java.lang.String fontSelectorPrompt)` The prompt for the built-in `font selector`.
    `void` | `setFontSizes(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontSizes)` ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
    `void` | `setFontSizeSelectorPrompt(java.lang.String fontSizeSelectorPrompt)` The prompt for the built-in `font-size selector`.
    `void` | `setFormatControls(ControlName... formatControls)` Default text formatting control group.
    `void` | `setFormatControls(java.lang.Object... formatControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setFormatControls(com.smartgwt.client.types.ControlName...) setFormatControls(ControlName...
    `void` | `setIndentPrompt(java.lang.String indentPrompt)` The prompt for the built-in `indent` control.
    `void` | `setItalicSelectionPrompt(java.lang.String italicSelectionPrompt)` The prompt for the built-in `italicSelection` control.
    `void` | `setJustifyPrompt(java.lang.String justifyPrompt)` The prompt for the built-in `justify` control.
    `void` | `setLinkPrompt(java.lang.String linkPrompt)` The prompt for the built-in `hyperlink` control.
    `void` | `setLinkUrlTitle(java.lang.String linkUrlTitle)` The prompt displayed when editing a hyperlink.
    `void` | `setListPropertiesPrompt(java.lang.String listPropertiesPrompt)` The prompt for the built-in `listProperties` control.
    `void` | `setListPropertiesWarningText(java.lang.String listPropertiesWarningText)` The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
    `com.smartgwt.logicalstructure.core.LogicalStructureObject` | `setLogicalStructure(com.smartgwt.logicalstructure.widgets.RichTextEditorLogicalStructure s)` Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
    `void` | `setMoveFocusOnTab(boolean moveFocusOnTab)` If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
    `void` | `setOrderedListPrompt(java.lang.String orderedListPrompt)` The prompt for the built-in `orderedList` control.
    `void` | `setOutdentPrompt(java.lang.String outdentPrompt)` The prompt for the built-in `outdent` control.
    `void` | `setPasteSelectionPrompt(java.lang.String pasteSelectionPrompt)` The prompt for the built-in `pasteSelection` control.
    `void` | `setStrikethroughSelectionPrompt(java.lang.String strikethroughSelectionPrompt)` The prompt for the built-in `strikethroughSelection` control.
    `void` | `setStyleControls(ControlName... styleControls)` Default text styling control group.
    `void` | `setStyleControls(java.lang.Object... styleControls)` Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): {@link com.smartgwt.client.widgets.RichTextEditor#setStyleControls(com.smartgwt.client.types.ControlName...) setStyleControls(ControlName...
    `void` | `setToolbarBackgroundColor(java.lang.String toolbarBackgroundColor)` The background color for the toolbar.
    `void` | `setUnderlineSelectionPrompt(java.lang.String underlineSelectionPrompt)` The prompt for the built-in `underlineSelection` control.
    `void` | `setUnorderedListPrompt(java.lang.String unorderedListPrompt)` The prompt for the built-in `unorderedList` control.
    `void` | `setValue(java.lang.String value)` Initial value for the edit area.

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.VLayout

      `setDefaultProperties, setLogicalStructure`

    - ### Methods inherited from class com.smartgwt.client.widgets.layout.Layout

      `addMember, addMember, addMember, addMember, addMemberPostCreate, addMemberPostCreate, addMemberPreCreate, addMemberPreCreate, addMembers, addMembers, addMembersChangedHandler, getAnimateMembers, getAnimateMemberTime, getCanDropComponents, getDefaultResizeBars, getDropComponent, getDropLine, getDropLineThickness, getDropPosition, getEditProxyConstructor, getEnforcePolicy, getHPolicy, getLayoutBottomMargin, getLayoutLeftMargin, getLayoutMargin, getLayoutRightMargin, getLayoutTopMargin, getLeaveScrollbarGap, getLocateMembersBy, getLocateMembersType, getManagePercentBreadth, getMember, getMember, getMemberDefaultBreadth, getMemberNumber, getMemberNumber, getMemberOverlap, getMembers, getMembersLength, getMembersMargin, getMinMemberSize, getOverflow, getPaddingAsLayoutMargin, getResizeBar, getResizeBarClass, getResizeBarSize, getReverseOrder, getShowDragPlaceHolder, getShowDropLines, getStackZIndex, getVertical, getVPolicy, hasMember, hideDropLine, hideMember, hideMember, layoutIsDirty, onInit_Layout, onInit, reflow, reflow, reflowNow, removeMember, removeMembers, removeMembers, reorderMember, reorderMembers, setAlign, setAlign, setAnimateMembers, setAnimateMemberTime, setCanDropComponents, setDefaultLayoutAlign, setDefaultLayoutAlign, setDefaultProperties, setDefaultResizeBars, setDropLineProperties, setDropLineThickness, setEditProxyConstructor, setEnforcePolicy, setHPolicy, setLayoutBottomMargin, setLayoutLeftMargin, setLayoutMargin, setLayoutRightMargin, setLayoutTopMargin, setLeaveScrollbarGap, setLocateMembersBy, setLocateMembersType, setLogicalStructure, setManagePercentBreadth, setMemberOverlap, setMembers, setMembersMargin, setMinMemberSize, setOverflow, setPaddingAsLayoutMargin, setPlaceHolderDefaults, setPlaceHolderProperties, setResizeBarClass, setResizeBarSize, setReverseOrder, setShowDragPlaceHolder, setShowDropLines, setStackZIndex, setVertical, setVisibleMember, setVPolicy, showMember, showMember`

    - ### Methods inherited from class com.smartgwt.client.widgets.Canvas

      `addChild, addChild, addChild, addChild, addChild, addClickHandler, addDoubleClickHandler, addDragMoveHandler, addDragRepositionMoveHandler, addDragRepositionStartHandler, addDragRepositionStopHandler, addDragResizeMoveHandler, addDragResizeStartHandler, addDragResizeStopHandler, addDragStartHandler, addDragStopHandler, addDropHandler, addDropMoveHandler, addDropOutHandler, addDropOverHandler, addFocusChangedHandler, addHoverHandler, addHoverHiddenHandler, addKeyDownHandler, addKeyPressHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseStillDownHandler, addMouseUpHandler, addMouseWheelHandler, addMovedHandler, addParentMovedHandler, addPeer, addPeer, addPeer, addPeer, addResizedHandler, addRightMouseDownHandler, addScrolledHandler, addShowContextMenuHandler, addSnapAlignCandidate, addStyleName, addVisibilityChangedHandler, adjustForContent, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateFade, animateHide, animateHide, animateHide, animateMove, animateMove, animateMove, animateMove, animateRect, animateRect, animateRect, animateRect, animateResize, animateResize, animateResize, animateResize, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateScroll, animateShow, animateShow, animateShow, animateShow, animateShow, animateShow, asSGWTComponent, blur, bringToFront, clear, clickMaskUp, clickMaskUp, contains, contains, containsEvent, containsFocus, containsPoint, containsPoint, deparent, depeer, disable, enable, encloses, focus, focusInNextTabElement, focusInPreviousTabElement, getAbsoluteLeft, getAbsoluteTop, getAccessKey, getAlwaysShowScrollbars, getAnimateAcceleration, getAnimateFadeTime, getAnimateHideAcceleration, getAnimateHideTime, getAnimateMoveAcceleration, getAnimateMoveTime, getAnimateRectAcceleration, getAnimateRectTime, getAnimateResizeAcceleration, getAnimateResizeTime, getAnimateScrollAcceleration, getAnimateScrollTime, getAnimateShowAcceleration, getAnimateShowEffect, getAnimateShowTime, getAnimateTime, getAppImgDir, getAriaRole, getAutoDraw, getAutoMaskComponents, getAutoShowParent, getBackgroundColor, getBackgroundImage, getBackgroundPosition, getBackgroundRepeat, getBorder, getBottom, getById, getByJSObject, getByLocalId, getCanAcceptDrop, getCanDrag, getCanDragReposition, getCanDragResize, getCanDragScroll, getCanDrop, getCanDropBefore, getCanFocus, getCanHover, getCanSelectText, getCanvasAutoChild, getCanvasItem, getChildren, getChildrenResizeSnapAlign, getChildrenSnapAlign, getChildrenSnapCenterAlign, getChildrenSnapEdgeAlign, getChildrenSnapResizeToGrid, getChildrenSnapToGrid, getClassName, getComponentMask, getComponentMaskDefaults, getContentElement, getContents, getContextMenu, getCursor, getDataPath, getDefaultHeight, getDefaultWidth, getDestroyed, getDestroying, getDisabled, getDisabledCursor, getDisableTouchScrollingForDrag, getDoubleClickDelay, getDragAppearance, getDragIntersectStyle, getDragMaskType, getDragOpacity, getDragRepositionAppearance, getDragRepositionCursor, getDragResizeAppearance, getDragScrollDelay, getDragStartDistance, getDragTarget, getDragType, getDropTypes, getDropTypesAsString, getDynamicContents, getEdgeBackgroundColor, getEdgeCenterBackgroundColor, getEdgeImage, getEdgeMarginSize, getEdgeOffset, getEdgeOpacity, getEdgeShowCenter, getEdgeSize, getEditNode, getEditProxy, getElement, getElement, getEventEdge, getEventEdge, getExtraSpace, getFacetId, getFormItemAutoChild, getFullDataPath, getGroupBorderCSS, getGroupLabelBackgroundColor, getGroupLabelStyleName, getGroupTitle, getHeight, getHeightAsString, getHideUsingDisplayNone, getHoverAlign, getHoverAutoDestroy, getHoverComponent, getHoverDelay, getHoverHeight, getHoverHTML, getHoverMoveWithMouse, getHoverOpacity, getHoverStyle, getHoverVAlign, getHoverWidth, getHoverWrap, getHSnapOrigin, getHSnapOrigin, getHSnapPosition, getHSnapPosition, getHtmlElement, getHtmlPosition, getImage, getImgURL, getImgURL, getInnerContentHeight, getInnerContentWidth, getInnerHeight, getInnerWidth, getIsGroup, getIsPrinting, getIsSnapAlignCandidate, getKeepInParentRect, getLayoutAlign, getLeavePageSpace, getLeft, getLeftAsString, getLocateChildrenBy, getLocateChildrenType, getLocatePeersBy, getLocatePeersType, getMargin, getMasterCanvas, getMasterElement, getMatchElement, getMaxHeight, getMaxWidth, getMenuConstructor, getMinHeight, getMinNonEdgeSize, getMinWidth, getMomentumScrollMinSpeed, getMouseStillDownDelay, getMouseStillDownInitialDelay, getNextZIndex, getNoDoubleClicks, getNoDropCursor, getOffsetHeight, getOffsetWidth, getOffsetX, getOffsetY, getOpacity, getOuterElement, getPadding, getPageBottom, getPageLeft, getPageRect, getPageRight, getPageTop, getPanelContainer, getParentCanvas, getParentElement, getPeers, getPercentBox, getPercentSource, getPosition, getPrefix, getPrintChildrenAbsolutelyPositioned, getPrintHTML, getPrintHTML, getPrompt, getProportionalResizeModifiers, getProportionalResizing, getRect, getRedrawOnResize, getResizeBarTarget, getResizeFrom, getRight, getScrollbarSize, getScrollBottom, getScrollHeight, getScrollLeft, getScrollRight, getScrollTop, getScrollWidth, getShadowDepth, getShadowImage, getShadowOffset, getShadowSoftness, getShouldPrint, getShowCustomScrollbars, getShowDragShadow, getShowEdges, getShowHover, getShowHoverComponents, getShowResizeBar, getShowShadow, getShowSnapGrid, getShrinkElementOnHide, getSkinImgDir, getSnapAlignCandidates, getSnapAlignCenterLineStyle, getSnapAlignEdgeLineStyle, getSnapAxis, getSnapEdge, getSnapHDirection, getSnapHGap, getSnapOffsetLeft, getSnapOffsetTop, getSnapOnDrop, getSnapPosition, getSnapPosition, getSnapResizeToAlign, getSnapResizeToGrid, getSnapTo, getSnapToAlign, getSnapToCenterAlign, getSnapToEdgeAlign, getSnapToGrid, getSnapVDirection, getSnapVGap, getStyleName, getTabIndex, getTestInstance, getTitle, getTooltip, getTop, getTopAsString, getTopElement, getUseBackMask, getUseDragMask, getUseNativeDrag, getUseOpacityFilter, getUseTouchScrolling, getValuesManager, getViewportHeight, getViewportWidth, getVisibility, getVisibleHeight, getVisibleWidth, getVSnapOrigin, getVSnapOrigin, getVSnapPosition, getVSnapPosition, getWidth, getWidthAsString, getZIndex, getZIndex, handleHover, hide, hideClickMask, hideClickMask, hideComponentMask, hideComponentMask, hideContextMenu, imgHTML, imgHTML, imgHTML, intersects, isDirty, isDisabled, isDrawn, isFocused, isVisible, keyUp, layoutChildren, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, linkHTML, markForDestroy, markForRedraw, markForRedraw, moveAbove, moveBelow, moveBy, moveTo, onAttach, onDetach, pageScrollDown, pageScrollUp, parentResized, placeNear, placeNear, placeNear, printComponents, provideRuleContext, redraw, redraw, removeChild, removeChild, removePeer, removePeer, removeSnapAlignCandidate, resizeBy, resizeTo, resizeTo, revealChild, revealChild, scrollBy, scrollByPercent, scrollTo, scrollTo, scrollTo, scrollToBottom, scrollToLeft, scrollToPercent, scrollToRight, scrollToTop, sendToBack, setAccessKey, setAllowExternalFilters, setAlwaysShowScrollbars, setAnimateAcceleration, setAnimateFadeTime, setAnimateHideAcceleration, setAnimateHideTime, setAnimateMoveAcceleration, setAnimateMoveTime, setAnimateRectAcceleration, setAnimateRectTime, setAnimateResizeAcceleration, setAnimateResizeTime, setAnimateScrollAcceleration, setAnimateScrollTime, setAnimateShowAcceleration, setAnimateShowEffect, setAnimateShowTime, setAnimateTime, setAppImgDir, setAriaRole, setAriaState, setAutoChildConstructor, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildProperties, setAutoChildVisibility, setAutoDraw, setAutoHeight, setAutoMaskComponents, setAutoShowParent, setAutoWidth, setBackgroundColor, setBackgroundImage, setBackgroundPosition, setBackgroundRepeat, setBorder, setBottom, setCanAcceptDrop, setCanDrag, setCanDragReposition, setCanDragResize, setCanDragScroll, setCanDrop, setCanDropBefore, setCanFocus, setCanHover, setCanSelectText, setChildren, setChildrenResizeSnapAlign, setChildrenSnapAlign, setChildrenSnapCenterAlign, setChildrenSnapEdgeAlign, setChildrenSnapResizeToGrid, setChildrenSnapToGrid, setComponentMaskDefaults, setContents, setContextMenu, setCursor, setDataPath, setDefaultHeight, setDefaultPageSpace, setDefaultProperties, setDefaultWidth, setDisabled, setDisabledCursor, setDisableTouchScrollingForDrag, setDoubleClickDelay, setDragAppearance, setDragIntersectStyle, setDragMaskType, setDragOpacity, setDragRepositionAppearance, setDragRepositionCursor, setDragResizeAppearance, setDragScrollDelay, setDragStartDistance, setDragTarget, setDragType, setDropTypes, setDropTypes, setDynamicContents, setEdgeBackgroundColor, setEdgeCenterBackgroundColor, setEdgeImage, setEdgeMarginSize, setEdgeOffset, setEdgeOpacity, setEdgeShowCenter, setEdgeSize, setEditMode, setEditMode, setEditMode, setElement, setExtraSpace, setFacetId, setGroupBorderCSS, setGroupLabelBackgroundColor, setGroupLabelStyleName, setGroupTitle, setHeight, setHeight, setHeight, setHeight100, setHideUsingDisplayNone, setHoverAlign, setHoverAutoDestroy, setHoverDelay, setHoverHeight, setHoverMoveWithMouse, setHoverOpacity, setHoverStyle, setHoverVAlign, setHoverWidth, setHoverWrap, setHtmlElement, setHtmlPosition, setImage, setImage, setInitHandler, setIsGroup, setIsSnapAlignCandidate, setKeepInParentRect, setKeepInParentRect, setKeepInParentRect, setLayoutAlign, setLayoutAlign, setLeavePageSpace, setLeft, setLeft, setLocateChildrenBy, setLocateChildrenType, setLocatePeersBy, setLocatePeersType, setLogicalStructure, setMargin, setMatchElement, setMaxHeight, setMaxWidth, setMenuConstructor, setMinHeight, setMinNonEdgeSize, setMinWidth, setMomentumScrollMinSpeed, setMouseStillDownDelay, setMouseStillDownInitialDelay, setNeverUseFilters, setNoDoubleClicks, setNoDropCursor, setOpacity, setPadding, setPageLeft, setPageTop, setParentCanvas, setParentElement, setPeers, setPercentBox, setPercentSource, setPosition, setPrefix, setPrintChildrenAbsolutelyPositioned, setPrompt, setProportionalResizeModifiers, setProportionalResizing, setRect, setRect, setRedrawOnResize, setResizeBarTarget, setResizeFrom, setResizeFrom, setRight, setScrollbarConstructor, setScrollbarSize, setShadowDepth, setShadowImage, setShadowOffset, setShadowSoftness, setShouldPrint, setShowCustomScrollbars, setShowDragShadow, setShowEdges, setShowHover, setShowHoverComponents, setShowResizeBar, setShowShadow, setShowSnapGrid, setShrinkElementOnHide, setSkinImgDir, setSmoothFade, setSnapAlignCandidates, setSnapAlignCenterLineStyle, setSnapAlignEdgeLineStyle, setSnapAxis, setSnapEdge, setSnapHDirection, setSnapHGap, setSnapOffsetLeft, setSnapOffsetTop, setSnapOnDrop, setSnapResizeToAlign, setSnapResizeToGrid, setSnapTo, setSnapToAlign, setSnapToCenterAlign, setSnapToEdgeAlign, setSnapToGrid, setSnapVDirection, setSnapVGap, setStyleName, setTabIndex, setTitle, setTooltip, setTop, setTop, setUseBackMask, setUseDragMask, setUseNativeDrag, setUseOpacityFilter, setUseTouchScrolling, setValuesManager, setVisibility, setVisible, setWidth, setWidth, setWidth, setWidth100, setZIndex, shouldDragScroll, show, showClickMask, showComponentMask, showComponentMask, showNextTo, showNextTo, showNextTo, showNextTo, showPrintPreview, showPrintPreview, showPrintPreview, showPrintPreview, showRecursively, updateEditNode, updateHover, updateHover, updateShadow, visibleAtPoint, willAcceptDrop`

    - ### Methods inherited from class com.smartgwt.client.widgets.BaseWidget

      `addDrawHandler, applyFactoryProperties, destroy, doAddHandler, doInit, doOnRender, draw, equals, error, errorIfNotCreated, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDateArray, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsFloatArray, getAttributeAsInt, getAttributeAsIntArray, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsRecord, getAttributeAsString, getAttributeAsStringArray, getConfig, getDOM, getHandlerCount, getID, getInnerHTML, getJsObj, getOrCreateJsObj, getRef, getScClassName, hasAutoAssignedID, hashCode, initNativeObject, internalSetID, internalSetID, isConfigOnly, isCreated, isFactoryCreated, onBind, onDestroy, onDraw, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setConfig, setConfigOnly, setDragTracker, setFactoryCreated, setID, setJavaScriptObject, setLogicalStructure, setNullProperty, setPosition, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setProperty, setScClassName, toString`

    - ### Methods inherited from class com.google.gwt.user.client.ui.Widget

      `addAttachHandler, addBitlessDomHandler, addDomHandler, addHandler, asWidget, asWidgetOrNull, createHandlerManager, delegateEvent, doAttachChildren, doDetachChildren, fireEvent, getLayoutData, getParent, isAttached, isOrWasAttached, onBrowserEvent, onLoad, onUnload, removeFromParent, setLayoutData, sinkEvents, unsinkEvents`

    - ### Methods inherited from class com.google.gwt.user.client.ui.UIObject

      `addStyleDependentName, ensureDebugId, ensureDebugId, ensureDebugId, getStyleElement, getStyleName, getStylePrimaryName, getStylePrimaryName, isVisible, onEnsureDebugId, removeStyleDependentName, removeStyleName, resolvePotentialElement, setElement, setPixelSize, setSize, setStyleDependentName, setStyleName, setStyleName, setStyleName, setStylePrimaryName, setStylePrimaryName, setVisible, sinkBitlessEvent`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### RichTextEditor

          public RichTextEditor()

    - #### RichTextEditor

          public RichTextEditor(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static RichTextEditor getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     Canvas defaults)

      Changes the defaults for Canvas AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - Canvas defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### changeAutoChildDefaults

          public static void changeAutoChildDefaults(java.lang.String autoChildName,
                                                     FormItem defaults)

      Changes the defaults for FormItem AutoChildren named `autoChildName`.
      Parameters:
        `autoChildName` - name of an AutoChild to customize the defaults for.
        `defaults` - FormItem defaults to apply. These defaults override any existing properties without destroying or wiping out non-overridden properties. For usage tips on this param, see `SGWTProperties`.
      See Also:
        `AutoChildUsage`

    - #### create

          protected com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `VLayout`

    - #### setAlignCenterPrompt

          public void setAlignCenterPrompt(java.lang.String alignCenterPrompt)

      The prompt for the built-in `alignCenter` control.
      Parameters:
        `alignCenterPrompt` - Default value is "Center selection"

    - #### getAlignCenterPrompt

          public java.lang.String getAlignCenterPrompt()

      The prompt for the built-in `alignCenter` control.
      Returns:
        String

    - #### setAlignLeftPrompt

          public void setAlignLeftPrompt(java.lang.String alignLeftPrompt)

      The prompt for the built-in `alignLeft` control.
      Parameters:
        `alignLeftPrompt` - Default value is "Left align selection"

    - #### getAlignLeftPrompt

          public java.lang.String getAlignLeftPrompt()

      The prompt for the built-in `alignLeft` control.
      Returns:
        String

    - #### setAlignRightPrompt

          public void setAlignRightPrompt(java.lang.String alignRightPrompt)

      The prompt for the built-in `alignRight` control.
      Parameters:
        `alignRightPrompt` - Default value is "Right align selection"

    - #### getAlignRightPrompt

          public java.lang.String getAlignRightPrompt()

      The prompt for the built-in `alignRight` control.
      Returns:
        String

    - #### setBackgroundColorPrompt

          public void setBackgroundColorPrompt(java.lang.String backgroundColorPrompt)

      The prompt for the built-in `backgroundColor` control.
      Parameters:
        `backgroundColorPrompt` - Default value is "Set selection background color"

    - #### getBackgroundColorPrompt

          public java.lang.String getBackgroundColorPrompt()

      The prompt for the built-in `backgroundColor` control.
      Returns:
        String

    - #### setBoldSelectionPrompt

          public void setBoldSelectionPrompt(java.lang.String boldSelectionPrompt)

      The prompt for the built-in `boldSelection` control.
      Parameters:
        `boldSelectionPrompt` - Default value is "Make selection bold"

    - #### getBoldSelectionPrompt

          public java.lang.String getBoldSelectionPrompt()

      The prompt for the built-in `boldSelection` control.
      Returns:
        String

    - #### setBulletControls

          public void setBulletControls(ControlName... bulletControls)
                                 throws java.lang.IllegalStateException

      Default HTML list control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"bulletControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `bulletControls` - Default value is ["indent", "outdent", "orderedList", "unorderedList", "listProperties"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setColorControls

          public void setColorControls(ControlName... colorControls)
                                throws java.lang.IllegalStateException

      Control group for modifying text color / background color. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `colorControls` - Default value is ["color", "backgroundColor"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setColorPrompt

          public void setColorPrompt(java.lang.String colorPrompt)

      The prompt for the built-in `color` control.
      Parameters:
        `colorPrompt` - Default value is "Set selection text color"

    - #### getColorPrompt

          public java.lang.String getColorPrompt()

      The prompt for the built-in `color` control.
      Returns:
        String

    - #### setCopySelectionPrompt

          public void setCopySelectionPrompt(java.lang.String copySelectionPrompt)

      The prompt for the built-in `copySelection` control.
      Parameters:
        `copySelectionPrompt` - Default value is "Copy selection"

    - #### getCopySelectionPrompt

          public java.lang.String getCopySelectionPrompt()

      The prompt for the built-in `copySelection` control.
      Returns:
        String

    - #### setCutSelectionPrompt

          public void setCutSelectionPrompt(java.lang.String cutSelectionPrompt)

      The prompt for the built-in `cutSelection` control.
      Parameters:
        `cutSelectionPrompt` - Default value is "Cut selection"

    - #### getCutSelectionPrompt

          public java.lang.String getCutSelectionPrompt()

      The prompt for the built-in `cutSelection` control.
      Returns:
        String

    - #### getEditArea

          public Canvas getEditArea()
                             throws java.lang.IllegalStateException

      The edit canvas created automatically for this RichTextEditor.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Canvas
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setEditAreaBackgroundColor

          public void setEditAreaBackgroundColor(java.lang.String editAreaBackgroundColor)
                                          throws java.lang.IllegalStateException

      Background color for the `edit canvas`.
      Parameters:
        `editAreaBackgroundColor` - Default value is "white"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getEditAreaBackgroundColor

          public java.lang.String getEditAreaBackgroundColor()

      Background color for the `edit canvas`.
      Returns:
        String

    - #### setFontControls

          public void setFontControls(ControlName... fontControls)
                               throws java.lang.IllegalStateException

      Default font control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"fontControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `fontControls` - Default value is ["fontSelector", "fontSizeSelector"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFontSelectorItem

          public SelectItem getFontSelectorItem()
                                         throws java.lang.IllegalStateException

      The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font to apply to the current selection.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setFontSelectorPrompt

          public void setFontSelectorPrompt(java.lang.String fontSelectorPrompt)

      The prompt for the built-in `font selector`.
      Parameters:
        `fontSelectorPrompt` - Default value is "Set Font..."

    - #### getFontSelectorPrompt

          public java.lang.String getFontSelectorPrompt()

      The prompt for the built-in `font selector`.
      Returns:
        String

    - #### getFontSizeSelectorItem

          public SelectItem getFontSizeSelectorItem()
                                             throws java.lang.IllegalStateException

      The `com.smartgwt.client.types.AutoChild` `SelectItem` used for choosing the font-size to apply to the current selection.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        SelectItem
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setFontSizeSelectorPrompt

          public void setFontSizeSelectorPrompt(java.lang.String fontSizeSelectorPrompt)

      The prompt for the built-in `font-size selector`.
      Parameters:
        `fontSizeSelectorPrompt` - Default value is "Set Font Size..."

    - #### getFontSizeSelectorPrompt

          public java.lang.String getFontSizeSelectorPrompt()

      The prompt for the built-in `font-size selector`.
      Returns:
        String

    - #### setFormatControls

          public void setFormatControls(ControlName... formatControls)
                                 throws java.lang.IllegalStateException

      Default text formatting control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"formatControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `formatControls` - Default value is ["alignLeft", "alignRight", "alignCenter", "justify"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setIndentPrompt

          public void setIndentPrompt(java.lang.String indentPrompt)

      The prompt for the built-in `indent` control.
      Parameters:
        `indentPrompt` - Default value is "Increase indent"

    - #### getIndentPrompt

          public java.lang.String getIndentPrompt()

      The prompt for the built-in `indent` control.
      Returns:
        String

    - #### setItalicSelectionPrompt

          public void setItalicSelectionPrompt(java.lang.String italicSelectionPrompt)

      The prompt for the built-in `italicSelection` control.
      Parameters:
        `italicSelectionPrompt` - Default value is "Make selection italic"

    - #### getItalicSelectionPrompt

          public java.lang.String getItalicSelectionPrompt()

      The prompt for the built-in `italicSelection` control.
      Returns:
        String

    - #### setJustifyPrompt

          public void setJustifyPrompt(java.lang.String justifyPrompt)

      The prompt for the built-in `justify` control.
      Parameters:
        `justifyPrompt` - Default value is "Full justify selection"

    - #### getJustifyPrompt

          public java.lang.String getJustifyPrompt()

      The prompt for the built-in `justify` control.
      Returns:
        String

    - #### setLinkPrompt

          public void setLinkPrompt(java.lang.String linkPrompt)

      The prompt for the built-in `hyperlink` control.
      Parameters:
        `linkPrompt` - Default value is "Edit Hyperlink"

    - #### getLinkPrompt

          public java.lang.String getLinkPrompt()

      The prompt for the built-in `hyperlink` control.
      Returns:
        String

    - #### setLinkUrlTitle

          public void setLinkUrlTitle(java.lang.String linkUrlTitle)

      The prompt displayed when editing a hyperlink.
      Parameters:
        `linkUrlTitle` - Default value is "Hyperlink URL:"

    - #### getLinkUrlTitle

          public java.lang.String getLinkUrlTitle()

      The prompt displayed when editing a hyperlink.
      Returns:
        String

    - #### getListPropertiesDialog

          public ListPropertiesDialog getListPropertiesDialog()
                                                       throws java.lang.IllegalStateException

      Dialog shown when the `"listProperties" control` is pressed. Provides options for the user to control formatting of lists.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        ListPropertiesDialog
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### setListPropertiesPrompt

          public void setListPropertiesPrompt(java.lang.String listPropertiesPrompt)

      The prompt for the built-in `listProperties` control.
      Parameters:
        `listPropertiesPrompt` - Default value is "Configure the list"

    - #### getListPropertiesPrompt

          public java.lang.String getListPropertiesPrompt()

      The prompt for the built-in `listProperties` control.
      Returns:
        String

    - #### setListPropertiesWarningText

          public void setListPropertiesWarningText(java.lang.String listPropertiesWarningText)

      The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
      Parameters:
        `listPropertiesWarningText` - Default value is "Place the cursor within a list to configure it"

    - #### getListPropertiesWarningText

          public java.lang.String getListPropertiesWarningText()

      The warning message displayed in a dialog when a user tries to configure a list without first putting the cursor in an appropriate place.
      Returns:
        String

    - #### setMoveFocusOnTab

          public void setMoveFocusOnTab(boolean moveFocusOnTab)

      If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
      If this method is called after the component has been drawn/initialized: Setter for `moveFocusOnTab`.
      Parameters:
        `moveFocusOnTab` - new value for moveFocusOnTab. Default value is true

    - #### getMoveFocusOnTab

          public boolean getMoveFocusOnTab()

      If the user presses the "Tab" key, should focus be taken from this editor? If set to `false` a "Tab" keypress will cause a Tab character to be inserted into the text, and focus will be left in the edit area.
      Returns:
        boolean

    - #### setOrderedListPrompt

          public void setOrderedListPrompt(java.lang.String orderedListPrompt)

      The prompt for the built-in `orderedList` control.
      Parameters:
        `orderedListPrompt` - Default value is "Convert to a numbered list"

    - #### getOrderedListPrompt

          public java.lang.String getOrderedListPrompt()

      The prompt for the built-in `orderedList` control.
      Returns:
        String

    - #### setOutdentPrompt

          public void setOutdentPrompt(java.lang.String outdentPrompt)

      The prompt for the built-in `outdent` control.
      Parameters:
        `outdentPrompt` - Default value is "Decrease indent"

    - #### getOutdentPrompt

          public java.lang.String getOutdentPrompt()

      The prompt for the built-in `outdent` control.
      Returns:
        String

    - #### setPasteSelectionPrompt

          public void setPasteSelectionPrompt(java.lang.String pasteSelectionPrompt)

      The prompt for the built-in `pasteSelection` control.
      Parameters:
        `pasteSelectionPrompt` - Default value is "Paste"

    - #### getPasteSelectionPrompt

          public java.lang.String getPasteSelectionPrompt()

      The prompt for the built-in `pasteSelection` control.
      Returns:
        String

    - #### setStrikethroughSelectionPrompt

          public void setStrikethroughSelectionPrompt(java.lang.String strikethroughSelectionPrompt)

      The prompt for the built-in `strikethroughSelection` control.
      Parameters:
        `strikethroughSelectionPrompt` - Default value is "Strike through selection"

    - #### getStrikethroughSelectionPrompt

          public java.lang.String getStrikethroughSelectionPrompt()

      The prompt for the built-in `strikethroughSelection` control.
      Returns:
        String

    - #### setStyleControls

          public void setStyleControls(ControlName... styleControls)
                                throws java.lang.IllegalStateException

      Default text styling control group. Consists of an array of `ControlName`s and/or `Canvas` instances. To display this group of controls for some RichTextEditor, include `"styleControls"` in the `controlGroups` array.

      Note : This is an advanced setting

      Parameters:
        `styleControls` - Default value is ["boldSelection", "italicSelection", "underlineSelection"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getToolArea

          public Layout getToolArea()
                             throws java.lang.IllegalStateException

      Layout used to contain all of the `toolbar` AutoChildren that contain the `controlGroups`.

      For an overview of how to use and configure AutoChildren, see `Using AutoChildren`.

      Returns:
        Layout
      Throws:
        `java.lang.IllegalStateException` - if this widget has not yet been rendered.

    - #### getToolbar

          public Layout getToolbar()

      Note : This API is non-functional (always returns null) and exists only to make you aware that this MultiAutoChild exists. See `Using AutoChildren` for details.

      Layout used to contain each of the `controlGroups`.

      Returns:
        null

    - #### setToolbarBackgroundColor

          public void setToolbarBackgroundColor(java.lang.String toolbarBackgroundColor)
                                         throws java.lang.IllegalStateException

      The background color for the toolbar.
      Parameters:
        `toolbarBackgroundColor` - Default value is "#CCCCCC"
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getToolbarBackgroundColor

          public java.lang.String getToolbarBackgroundColor()

      The background color for the toolbar.
      Returns:
        String

    - #### setUnderlineSelectionPrompt

          public void setUnderlineSelectionPrompt(java.lang.String underlineSelectionPrompt)

      The prompt for the built-in `underlineSelection` control.
      Parameters:
        `underlineSelectionPrompt` - Default value is "Make selection underlined"

    - #### getUnderlineSelectionPrompt

          public java.lang.String getUnderlineSelectionPrompt()

      The prompt for the built-in `underlineSelection` control.
      Returns:
        String

    - #### setUnorderedListPrompt

          public void setUnorderedListPrompt(java.lang.String unorderedListPrompt)

      The prompt for the built-in `unorderedList` control.
      Parameters:
        `unorderedListPrompt` - Default value is "Convert to a bullet list"

    - #### getUnorderedListPrompt

          public java.lang.String getUnorderedListPrompt()

      The prompt for the built-in `unorderedList` control.
      Returns:
        String

    - #### setValue

          public void setValue(java.lang.String value)

      Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
      If this method is called after the component has been drawn/initialized: Updates the current value of the edit area.
      Parameters:
        `value` - Default value is ""

    - #### getValue

          public java.lang.String getValue()

      Initial value for the edit area. Use `getValue()` and `setValue()` to update at runtime.
      Returns:
        Retrieves the current value of the edit area.

    - #### doWarn

          public void doWarn()

      Display a warning if Rich Text Editing is not fully supported in this browser. Default behavior logs a warning to the developer console - Override this if a user-visible warning is required

    - #### richEditorSupported

          public java.lang.Boolean richEditorSupported()

      Does this browser support the full RichTextEditor feature set. Returns false for browsers in which some features are not natively supported (Safari before version 3.1 and Opera before version 9.50).
      Returns:
        false if this browser doesn't fully support RichTextEditing

    - #### setDefaultProperties

          public static void setDefaultProperties(RichTextEditor richTextEditorProperties)

      Class level method to set the default properties of this class. If set, then all existing and subsequently created instances of this class will automatically have default properties corresponding to the properties set on the SmartGWT class instance passed to this function before its underlying SmartClient JS object was created. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will affect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead. Calling this method after instances have been created can result in undefined behavior, since it bypasses any setters and a class instance may have already examined a particular property and not be expecting any changes through this route.

      Parameters:
        `richTextEditorProperties` - properties that should be used as new defaults when instances of this class are created
      See Also:
        `SGWTProperties`

    - #### setControlGroups

          public void setControlGroups(java.lang.String... controlGroups)

      An array of control group names specifying which groups of controls should be included in the editor tool area. The special string "break" may also be included in this array to cause the subsequent control groups to continue onto a new line.
      Parameters:
        `controlGroups` - the control groups. Default is ["fontControls", "formatControls", "styleControls", "colorControls"]
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setControlGroups

          public void setControlGroups(java.lang.Object... controlGroups)
                                throws java.lang.IllegalStateException

      An array of control groups specifying which groups of controls should be included in the editor tool area. The values of this array may be a `StandardControlGroup` enum value, the name of a control group (String), a `Canvas`, or the special string "break" which causes the subsequent control groups to continue onto a new line.
      Parameters:
        `controlGroups` - the control groups. Default is [ `FONTCONTROLS`, `FORMATCONTROLS`, `STYLECONTROLS`, `COLORCONTROLS`].
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setBulletControls

          public void setBulletControls(java.lang.Object... bulletControls)
                                 throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setBulletControls(ControlName... bulletControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setColorControls

          public void setColorControls(java.lang.Object... colorControls)
                                throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setColorControls(ControlName... colorControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setFontControls

          public void setFontControls(java.lang.Object... fontControls)
                               throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFontControls(ControlName... fontControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setFormatControls

          public void setFormatControls(java.lang.Object... formatControls)
                                 throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setFormatControls(ControlName... formatControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### setStyleControls

          public void setStyleControls(java.lang.Object... styleControls)
                                throws java.lang.IllegalStateException

      Use this signature if you plan to pass a mixture of standard ControlNames and custom widgets (any subclass of Canvas is allowed): `setStyleControls(ControlName... styleControls)`
      Throws:
        `java.lang.IllegalStateException`

    - #### getFontNames

          public final java.util.Map<java.lang.String,java.lang.String> getFontNames()

      ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
      Returns:
        the current fontNames valueMap

    - #### setFontNames

          public void setFontNames(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontNames)
                            throws java.lang.IllegalStateException

      ValueMap of CSS fontName properties to font name titles to display in the font selector for the `FONTSELECTOR` control.
      Parameters:
        `fontNames` - the new ValueMap
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### getFontSizes

          public final java.util.Map<java.lang.String,java.lang.String> getFontSizes()

      ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
      Returns:
        the current fontNames valueMap

    - #### setFontSizes

          public void setFontSizes(java.util.LinkedHashMap<java.lang.String,java.lang.String> fontSizes)
                            throws java.lang.IllegalStateException

      ValueMap of CSS font size property values to font size titles to display in the font size selector for the `FONTSIZESELECTOR` control.
      Parameters:
        `fontSizes` - the new ValueMap
      Throws:
        `java.lang.IllegalStateException` - this property cannot be changed after the component has been created

    - #### setLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject setLogicalStructure(com.smartgwt.logicalstructure.widgets.RichTextEditorLogicalStructure s)

      Setter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.

    - #### getLogicalStructure

          public com.smartgwt.logicalstructure.core.LogicalStructureObject getLogicalStructure()

      Getter implementing the `LogicalStructure` interface, which supports Eclipse's logical structure debugging facility.
      Specified by:
        `getLogicalStructure` in interface `LogicalStructure`
      Overrides:
        `getLogicalStructure` in class `VLayout`